//*******************************************************
// Photo Box with ATmega64 or Atmega2560
// CPU Clock:O16MHz Ext,Crystal 16MHz)
//   iq[Yf[^@WȂŊOUɂj
//
//  file name: disp_8x48_dot.c
//

#ifdef	cpu64
//@@@PE4:COL1  High:Active
//@@@PE5:COL2  High:Active
//@@@PE6:COL3  High:Active
//@@@PE7:COL4  High:Active
//@@@PD4:COL5  High:Active
//@@@PD5:COL6  High:Active
//@@@PD6:COL7  High:Active
//@@@PD7:COL8  High:Active
//@@@PE2:COL9  High:Active
//@@@PF1:COL10 High:Active
//@@@PF2:COL11 High:Active
//@@@PF3:CO_12 High:Active
//@@@PF4:COL13 High:Active
//@@@PF5:COL14 High:Active
//@@@PF5:COL15 High:Active
//@@@PF7:COL16 High:Active
//
//@@@*** block-1 (E1 & E2) ***
//@@@PA0:ROW1 Low:Active
//@@@PA1:ROW2 Low:Active
//@@@PA2:ROW3 Low:Active
//@@@PA3:ROW4 Low:Active
//@@@PA4:ROW5 Low:Active
//@@@PA5:ROW6 Low:Active
//@@@PA6:ROW7 Low:Active
//@@@PA7:ROW8 Low:Active
//
//@@@*** block-2 (E3 & E4) ***
//@@@PB0:ROW1 Low:Active
//@@@PB1:ROW2 Low:Active
//@@@PB2:ROW3 Low:Active
//@@@PB3:ROW4 Low:Active
//@@@PB4:ROW5 Low:Active
//@@@PB5:ROW6 Low:Active
//@@@PB6:ROW7 Low:Active
//@@@PB7:ROW8 Low:Active
//
//@@@*** block-3 (E5 & E6) ***
//@@@PC0:ROW1 Low:Active
//@@@PC1:ROW2 Low:Active
//@@@PC2:ROW3 Low:Active
//@@@PC3:ROW4 Low:Active
//@@@PC4:ROW5 Low:Active
//@@@PC5:ROW6 Low:Active
//@@@PC6:ROW7 Low:Active
//@@@PC7:ROW8 Low:Active
#else
 #ifdef cpu2560
//@@@*** block-1 (E1 & E2) ***
//@@@PH0:COL1  High:Active
//@@@PH1:COL2  High:Active
//@@@PH2:COL3  High:Active
//@@@PH3:COL4  High:Active
//@@@PH4:COL5  High:Active
//@@@PH5:COL6  High:Active
//@@@PH6:COL7  High:Active
//@@@PH7:COL8  High:Active
//@@@PJ0:COL9  High:Active
//@@@PJ1:COL10 High:Active
//@@@PJ2:COL11 High:Active
//@@@PJ3:CO_12 High:Active
//@@@PJ4:COL13 High:Active
//@@@PJ5:COL14 High:Active
//@@@PJ6:COL15 High:Active
//@@@PJ7:COL16 High:Active
//
//@@@*** block-2 (E3 & E4) ***
//@@@PK0:COL1  High:Active
//@@@PK1:COL2  High:Active
//@@@PK2:COL3  High:Active
//@@@PK3:COL4  High:Active
//@@@PK4:COL5  High:Active
//@@@PK5:COL6  High:Active
//@@@PK6:COL7  High:Active
//@@@PK7:COL8  High:Active
//@@@PL0:COL9  High:Active
//@@@PL1:COL10 High:Active
//@@@PL2:COL11 High:Active
//@@@PL3:CO_12 High:Active
//@@@PL4:COL13 High:Active
//@@@PL5:COL14 High:Active
//@@@PL6:COL15 High:Active
//@@@PL7:COL16 High:Active
//
//@@@*** block-3 (E5 & E6) ***
//@@@PG0:COL1  High:Active
//@@@PG1:COL2  High:Active
//@@@PG2:COL3  High:Active
//@@@PG3:COL4  High:Active
//@@@PD4:COL5  High:Active
//@@@PD5:COL6  High:Active
//@@@PD6:COL7  High:Active
//@@@PD7:COL8  High:Active
//@@@PB0:COL9  High:Active
//@@@PF1:COL10 High:Active
//@@@PF2:COL11 High:Active
//@@@PF3:CO_12 High:Active
//@@@PF4:COL13 High:Active
//@@@PF5:COL14 High:Active
//@@@PF6:COL15 High:Active
//@@@PF7:COL16 High:Active
//
//@@@*** block-1 (E1 & E2) ***
//@@@PA0:ROW1 Low:Active
//@@@PA1:ROW2 Low:Active
//@@@PA2:ROW3 Low:Active
//@@@PA3:ROW4 Low:Active
//@@@PA4:ROW5 Low:Active
//@@@PA5:ROW6 Low:Active
//@@@PA6:ROW7 Low:Active
//@@@PA7:ROW8 Low:Active
//
//@@@*** block-2 (E3 & E4) ***
//@@@PC0:ROW1 Low:Active
//@@@PC1:ROW2 Low:Active
//@@@PC2:ROW3 Low:Active
//@@@PC3:ROW4 Low:Active
//@@@PC4:ROW5 Low:Active
//@@@PC5:ROW6 Low:Active
//@@@PC6:ROW7 Low:Active
//@@@PC7:ROW8 Low:Active
//
//@@@*** block-3 (E5 & E6) ***
//@@@PE0:ROW1 Low:Active
//@@@PE1:ROW2 Low:Active
//@@@PE2:ROW3 Low:Active
//@@@PE3:ROW4 Low:Active
//@@@PE4:ROW5 Low:Active
//@@@PE5:ROW6 Low:Active
//@@@PE6:ROW7 Low:Active
//@@@PE7:ROW8 Low:Active
 #endif
#endif
//
//  2022/11/29 New(TAB4)	taishi for nega48 & Character Mode only, Anode Common only
//  2023/12/09 Modify for Photo Box with ATmega64 Taishi
//  2024/01/09 Modify for Photo Box with ATmega64 or ATmega2560 Taishi
//*******************************************************

#include	<avr/io.h>
#include	<avr/pgmspace.h>

#include	"pr_mega64_2560_photo_box_h.h"
#include	"timer_h.h"
#include	"ad_conv_h.h"
#include	"pfont5x7_h.h"
#include	"secdot5x7_h.h"
#include	"ofont8x8_h.h"
#include	"port_bit_h.h"
#include	"Rtc_Rx8900_h.h"
#include	"disp_clock_data_h.h"

#include	"disp_8x48_dot_h.h"

#ifdef	cpu64
// bnkAm[h̎
// _Ci~bN_̃Rƍl镨͂bnkP`PUƂ		bnkAm[h
const unsigned char	col_data_PD_off=0b00001111;	// oĉbnkf[^neef[^i`mcj
const unsigned char	col_data_PD[16]={				//  REɓ
									 0b00000000,	//[0]	// COL1
									 0b00000000,	//[1]	// COL2
									 0b00000000,	//[2]	// COL3
									 0b00000000,	//[3]	// COL4
									 0b00010000,	//[4]	// COL5
									 0b00100000,	//[5]	// COL6
									 0b01000000,	//[6]	// COL7
									 0b10000000,	//[7]	// COL8
									 0b00000000,	//[8]	// COL9
									 0b00000000,	//[9]	// COL10
									 0b00000000,	//[10]	// COL11
									 0b00000000,	//[11]	// COL12
									 0b00000000,	//[12]	// COL13
									 0b00000000,	//[13]	// COL14
									 0b00000000,	//[14]	// COL15
									 0b00000000,	//[15]	// COL16
};
const unsigned char	col_data_PE_off= 0b00001011;	// od̂bnkf[^neef[^i`mcj
const unsigned char	col_data_PE[16]={				//  REɓ
									 0b00010000,	//[0]	// COL1
									 0b00100000,	//[1]	// COL2
									 0b01000000,	//[2]	// COL3
									 0b10000000,	//[3]	// COL4
									 0b00000000,	//[4]	// COL5
									 0b00000000,	//[5]	// COL6
									 0b00000000,	//[6]	// COL7
									 0b00000000,	//[7]	// COL8
									 0b00000100,	//[8]	// COL9
									 0b00000000,	//[9]	// COL10
									 0b00000000,	//[10]	// COL11
									 0b00000000,	//[11]	// COL12
									 0b00000000,	//[12]	// COL13
									 0b00000000,	//[13]	// COL14
									 0b00000000,	//[14]	// COL15
									 0b00000000,	//[15]	// COL16
};
const unsigned char	col_data_PF_off= 0b00000001;	// oêbnkf[^neef[^i`mcj
const unsigned char	col_data_PF[16]={				//  REɓ
									 0b00000000,	//[0]	// COL1
									 0b00000000,	//[1]	// COL2
									 0b00000000,	//[2]	// COL3
									 0b00000000,	//[3]	// COL4
									 0b00000000,	//[4]	// COL5
									 0b00000000,	//[5]	// COL6
									 0b00000000,	//[6]	// COL7
									 0b00000000,	//[7]	// COL8
									 0b00000000,	//[8]	// COL9
									 0b00000010,	//[9]	// COL10
									 0b00000100,	//[10]	// COL11
									 0b00001000,	//[11]	// COL12
									 0b00010000,	//[12]	// COL13
									 0b00100000,	//[13]	// COL14
									 0b01000000,	//[14]	// COL15
									 0b10000000,	//[15]	// COL16
};


const unsigned char	row_data_off =0b11111111;		// qnvf[^neef[^
unsigned char	row_data[48+8]={						// SWł悢]TŁ{W
									 0b11111111,	//[0]	// ROW1 E-1
									 0b11111111,	//[1]	// ROW2 E-1
									 0b11111111,	//[2]	// ROW3 E-1
									 0b11111111,	//[3]	// ROW4 E-1
									 0b11111111,	//[4]	// ROW5 E-1
									 0b11111111,	//[5]	// ROW6 E-1
									 0b11111111,	//[6]	// ROW7 E-1
									 0b11111111,	//[7]	// ROW8 E-1
									 0b11111111,	//[8]	// ROW1 E-2
									 0b11111111,	//[9]	// ROW2 E-2
									 0b11111111,	//[10]	// ROW3 E-2
									 0b11111111,	//[11]	// ROW4 E-2
									 0b11111111,	//[12]	// ROW5 E-2
									 0b11111111,	//[13]	// ROW6 E-2
									 0b11111111,	//[14]	// ROW7 E-2
									 0b11111111,	//[15]	// ROW8 E-2

									 0b11111111,	//[16]	// ROW1 E-3
									 0b11111111,	//[17]	// ROW2 E-3
									 0b11111111,	//[18]	// ROW3 E-3
									 0b11111111,	//[19]	// ROW4 E-3
									 0b11111111,	//[20]	// ROW5 E-3
									 0b11111111,	//[21]	// ROW6 E-3
									 0b11111111,	//[22]	// ROW7 E-3
									 0b11111111,	//[23]	// ROW8 E-3
									 0b11111111,	//[24]	// ROW1 E-4
									 0b11111111,	//[25]	// ROW2 E-4
									 0b11111111,	//[26]	// ROW3 E-4
									 0b11111111,	//[27]	// ROW4 E-4
									 0b11111111,	//[28]	// ROW5 E-4
									 0b11111111,	//[29]	// ROW6 E-4
									 0b11111111,	//[30]	// ROW7 E-4
									 0b11111111,	//[31]	// ROW8 E-4

									 0b11111111,	//[32]	// ROW1 E-5
									 0b11111111,	//[33]	// ROW2 E-5
									 0b11111111,	//[34]	// ROW3 E-5
									 0b11111111,	//[35]	// ROW4 E-5
									 0b11111111,	//[36]	// ROW5 E-5
									 0b11111111,	//[37]	// ROW6 E-5
									 0b11111111,	//[38]	// ROW7 E-5
									 0b11111111,	//[39]	// ROW8 E-5
									 0b11111111,	//[40]	// ROW1 E-6
									 0b11111111,	//[41]	// ROW2 E-6
									 0b11111111,	//[42]	// ROW3 E-6
									 0b11111111,	//[43]	// ROW4 E-6
									 0b11111111,	//[44]	// ROW5 E-6
									 0b11111111,	//[45]	// ROW6 E-6
									 0b11111111,	//[46]	// ROW7 E-6
									 0b11111111,	//[47]	// ROW8 E-6

};
#else
 #ifdef cpu2560
// bnkAm[h̎
// _Ci~bN_̃Rƍl镨͂bnkP`PUƂ		bnkAm[h
// *** Block-1 E1 & E2 Common ***
static	const unsigned char	col_data_PH_off= 0b00000000;	// oĝbnkf[^neef[^i`mcj
static	const unsigned char	col_data_PH[16]={		//  REɓ
									 0b00000001,	//[0]	// COL1
									 0b00000010,	//[1]	// COL2
									 0b00000100,	//[2]	// COL3
									 0b00001000,	//[3]	// COL4
									 0b00010000,	//[4]	// COL5
									 0b00100000,	//[5]	// COL6
									 0b01000000,	//[6]	// COL7
									 0b10000000,	//[7]	// COL8
									 0b00000000,	//[8]	// COL9
									 0b00000000,	//[9]	// COL10
									 0b00000000,	//[10]	// COL11
									 0b00000000,	//[11]	// COL12
									 0b00000000,	//[12]	// COL13
									 0b00000000,	//[13]	// COL14
									 0b00000000,	//[14]	// COL15
									 0b00000000,	//[15]	// COL16
};
static	const unsigned char	col_data_PJ_off= 0b00000000;	// oîbnkf[^neef[^i`mcj
static	const unsigned char	col_data_PJ[16]={		//  REɓ
									 0b00000000,	//[0]	// COL1
									 0b00000000,	//[1]	// COL2
									 0b00000000,	//[2]	// COL3
									 0b00000000,	//[3]	// COL4
									 0b00000000,	//[4]	// COL5
									 0b00000000,	//[5]	// COL6
									 0b00000000,	//[6]	// COL7
									 0b00000000,	//[7]	// COL8
									 0b00000001,	//[8]	// COL9
									 0b00000010,	//[9]	// COL10
									 0b00000100,	//[10]	// COL11
									 0b00001000,	//[11]	// COL12
									 0b00010000,	//[12]	// COL13
									 0b00100000,	//[13]	// COL14
									 0b01000000,	//[14]	// COL15
									 0b10000000,	//[15]	// COL16
};

// *** Block-2 E3 & E4 Common ***
static	const unsigned char	col_data_PK_off= 0b00000000;	// oĵbnkf[^neef[^i`mcj
static	const unsigned char	col_data_PK[16]={		//  REɓ
									 0b00000001,	//[0]	// COL1
									 0b00000010,	//[1]	// COL2
									 0b00000100,	//[2]	// COL3
									 0b00001000,	//[3]	// COL4
									 0b00010000,	//[4]	// COL5
									 0b00100000,	//[5]	// COL6
									 0b01000000,	//[6]	// COL7
									 0b10000000,	//[7]	// COL8
									 0b00000000,	//[8]	// COL9
									 0b00000000,	//[9]	// COL10
									 0b00000000,	//[10]	// COL11
									 0b00000000,	//[11]	// COL12
									 0b00000000,	//[12]	// COL13
									 0b00000000,	//[13]	// COL14
									 0b00000000,	//[14]	// COL15
									 0b00000000,	//[15]	// COL16
};
static	const unsigned char	col_data_PL_off= 0b00000000;	// ok̂bnkf[^neef[^i`mcj
static	const unsigned char	col_data_PL[16]={		//  REɓ
									 0b00000000,	//[0]	// COL1
									 0b00000000,	//[1]	// COL2
									 0b00000000,	//[2]	// COL3
									 0b00000000,	//[3]	// COL4
									 0b00000000,	//[4]	// COL5
									 0b00000000,	//[5]	// COL6
									 0b00000000,	//[6]	// COL7
									 0b00000000,	//[7]	// COL8
									 0b00000001,	//[8]	// COL9
									 0b00000010,	//[9]	// COL10
									 0b00000100,	//[10]	// COL11
									 0b00001000,	//[11]	// COL12
									 0b00010000,	//[12]	// COL13
									 0b00100000,	//[13]	// COL14
									 0b01000000,	//[14]	// COL15
									 0b10000000,	//[15]	// COL16
};

// *** Block-3 E5 Common ***
static	const unsigned char	col_data_PG_off= 0b11110000;	// od̂bnkf[^neef[^i`mcj
static	const unsigned char	col_data_PG[16]={		//  REɓ
									 0b00000001,	//[0]	// COL1
									 0b00000010,	//[1]	// COL2
									 0b00000100,	//[2]	// COL3
									 0b00001000,	//[3]	// COL4
									 0b00000000,	//[4]	// COL5
									 0b00000000,	//[5]	// COL6
									 0b00000000,	//[6]	// COL7
									 0b00000000,	//[7]	// COL8
									 0b00000000,	//[8]	// COL9
									 0b00000000,	//[9]	// COL10
									 0b00000000,	//[10]	// COL11
									 0b00000000,	//[11]	// COL12
									 0b00000000,	//[12]	// COL13
									 0b00000000,	//[13]	// COL14
									 0b00000000,	//[14]	// COL15
									 0b00000000,	//[15]	// COL16
};

static	const unsigned char	col_data_PD_off= 0b00001111;	// oĉbnkf[^neef[^i`mcj
static	const unsigned char	col_data_PD[16]={		//  REɓ
									 0b00000000,	//[0]	// COL1
									 0b00000000,	//[1]	// COL2
									 0b00000000,	//[2]	// COL3
									 0b00000000,	//[3]	// COL4
									 0b00010000,	//[4]	// COL5
									 0b00100000,	//[5]	// COL6
									 0b01000000,	//[6]	// COL7
									 0b10000000,	//[7]	// COL8
									 0b00000000,	//[8]	// COL9
									 0b00000000,	//[9]	// COL10
									 0b00000000,	//[10]	// COL11
									 0b00000000,	//[11]	// COL12
									 0b00000000,	//[12]	// COL13
									 0b00000000,	//[13]	// COL14
									 0b00000000,	//[14]	// COL15
									 0b00000000,	//[15]	// COL16
};

// *** Block-3 E6 Common ***
static	const unsigned char	col_data_PB_off= 0b11111110;	// oâbnkf[^neef[^i`mcj
static	const unsigned char	col_data_PB[16]={		//  REɓ
									 0b00000000,	//[0]	// COL1
									 0b00000000,	//[1]	// COL2
									 0b00000000,	//[2]	// COL3
									 0b00000000,	//[3]	// COL4
									 0b00000000,	//[4]	// COL5
									 0b00000000,	//[5]	// COL6
									 0b00000000,	//[6]	// COL7
									 0b00000000,	//[7]	// COL8
									 0b00000001,	//[8]	// COL9
									 0b00000000,	//[9]	// COL10
									 0b00000000,	//[10]	// COL11
									 0b00000000,	//[11]	// COL12
									 0b00000000,	//[12]	// COL13
									 0b00000000,	//[13]	// COL14
									 0b00000000,	//[14]	// COL15
									 0b00000000,	//[15]	// COL16
};

static	const unsigned char	col_data_PF_off= 0b00000001;	// oêbnkf[^neef[^i`mcj
static	const unsigned char	col_data_PF[16]={		//  REɓ
									 0b00000000,	//[0]	// COL1
									 0b00000000,	//[1]	// COL2
									 0b00000000,	//[2]	// COL3
									 0b00000000,	//[3]	// COL4
									 0b00000000,	//[4]	// COL5
									 0b00000000,	//[5]	// COL6
									 0b00000000,	//[6]	// COL7
									 0b00000000,	//[7]	// COL8
									 0b00000000,	//[8]	// COL9
									 0b00000010,	//[9]	// COL10
									 0b00000100,	//[10]	// COL11
									 0b00001000,	//[11]	// COL12
									 0b00010000,	//[12]	// COL13
									 0b00100000,	//[13]	// COL14
									 0b01000000,	//[14]	// COL15
									 0b10000000,	//[15]	// COL16
};

static	const unsigned char	row_data_off =   0b11111111;	// qnvf[^neef[^

static	unsigned char	row_data[48+8]={			// SWł悢]TŁ{W
									 0b11111111,	//[0]	// ROW1 E-1
									 0b11111111,	//[1]	// ROW2 E-1
									 0b11111111,	//[2]	// ROW3 E-1
									 0b11111111,	//[3]	// ROW4 E-1
									 0b11111111,	//[4]	// ROW5 E-1
									 0b11111111,	//[5]	// ROW6 E-1
									 0b11111111,	//[6]	// ROW7 E-1
									 0b11111111,	//[7]	// ROW8 E-1
									 0b11111111,	//[8]	// ROW1 E-2
									 0b11111111,	//[9]	// ROW2 E-2
									 0b11111111,	//[10]	// ROW3 E-2
									 0b11111111,	//[11]	// ROW4 E-2
									 0b11111111,	//[12]	// ROW5 E-2
									 0b11111111,	//[13]	// ROW6 E-2
									 0b11111111,	//[14]	// ROW7 E-2
									 0b11111111,	//[15]	// ROW8 E-2

									 0b11111111,	//[16]	// ROW1 E-3
									 0b11111111,	//[17]	// ROW2 E-3
									 0b11111111,	//[18]	// ROW3 E-3
									 0b11111111,	//[19]	// ROW4 E-3
									 0b11111111,	//[20]	// ROW5 E-3
									 0b11111111,	//[21]	// ROW6 E-3
									 0b11111111,	//[22]	// ROW7 E-3
									 0b11111111,	//[23]	// ROW8 E-3
									 0b11111111,	//[24]	// ROW1 E-4
									 0b11111111,	//[25]	// ROW2 E-4
									 0b11111111,	//[26]	// ROW3 E-4
									 0b11111111,	//[27]	// ROW4 E-4
									 0b11111111,	//[28]	// ROW5 E-4
									 0b11111111,	//[29]	// ROW6 E-4
									 0b11111111,	//[30]	// ROW7 E-4
									 0b11111111,	//[31]	// ROW8 E-4

									 0b11111111,	//[32]	// ROW1 E-5
									 0b11111111,	//[33]	// ROW2 E-5
									 0b11111111,	//[34]	// ROW3 E-5
									 0b11111111,	//[35]	// ROW4 E-5
									 0b11111111,	//[36]	// ROW5 E-5
									 0b11111111,	//[37]	// ROW6 E-5
									 0b11111111,	//[38]	// ROW7 E-5
									 0b11111111,	//[39]	// ROW8 E-5
									 0b11111111,	//[40]	// ROW1 E-6
									 0b11111111,	//[41]	// ROW2 E-6
									 0b11111111,	//[42]	// ROW3 E-6
									 0b11111111,	//[43]	// ROW4 E-6
									 0b11111111,	//[44]	// ROW5 E-6
									 0b11111111,	//[45]	// ROW6 E-6
									 0b11111111,	//[46]	// ROW7 E-6
									 0b11111111,	//[47]	// ROW8 E-6

};
 #endif
#endif

unsigned char	gSet_count = 0;						// 邢\͂OAÂ\͂R

#ifdef	cpu64
//***************************
// 8x48 dot Dispaly X^eBbN`FbN mega64
//  ݋֎~ԂŌĂ΂鎖
//  荞݂g킸ɁAX^eBbN
//  ehbg̕\B
//  ォ牺ɂPhbgPbԊuœA
//  JԂB
//  rłrdkdbsXCb`ꂽA
//  ㉺̕\ʒu͂̂܂܂ɂB
//  ÉArdsXCb`ꂽAB
//
//  ̊֐͔ɉiɓJԂ
//***************************
void	check_8x48_dot_static(void)
{
	unsigned char	uc;
	unsigned char	stop_yoko_run=0;		// 1 :row bit number inc. stop
	unsigned char	yoko_bit=0x80;			// row bit data
	unsigned char	tate_bit_num=0;			// common(col) bit number
	unsigned char	s1_select_stat=0;		// SELECT SW
	unsigned char	s2_set_stat=0;			// SET SW
	unsigned char	count_for_1sec=0;		// counter for 1sec


	PORTA = ~yoko_bit;						// row set block-1
	PORTB = ~yoko_bit;						// row set block-2
	PORTC = ~yoko_bit;						// row set block-3
	PORTD |= col_data_PD[tate_bit_num];		// common set
	PORTE |= col_data_PE[tate_bit_num];		// common set
	PORTF |= col_data_PF[tate_bit_num];		// common set

	wait_sw_off();							// Q̃XCb`Q@܂ŉiv[v

	while(1){
		if(count_for_1sec == 0){
			PORTD &= col_data_PD_off;		// common off
			PORTE &= col_data_PE_off;		// common off
			PORTF &= col_data_PF_off;		// common off
			if(stop_yoko_run == 0){			// togle row bit number inc. stop
				PORTA = ~yoko_bit;			// row set block-1
				PORTB = ~yoko_bit;			// row set block-2
				PORTC = ~yoko_bit;			// row set block-3
				yoko_bit >>= 1;
				if(yoko_bit==0){
					yoko_bit = 0x80;
				}
			}
			PORTD |= col_data_PD[tate_bit_num];	// common set
			PORTE |= col_data_PE[tate_bit_num];	// common set
			PORTF |= col_data_PF[tate_bit_num];	// common set
		}

		uc = check_s1_sw_on();				// SET
		if(s1_select_stat != uc){			// Ԃς
			s1_select_stat = uc;			// ݂̏ԕۑ
			if(s1_select_stat == 1){		// @XCb`ꂽ
				stop_yoko_run ^= 1;			// togle row bit number inc. stop
			}
		}

		uc = check_s2_sw_on();				// SELECTT
		if(s2_set_stat != uc){				// Ԃς
			s2_set_stat = uc;				// ݂̏ԕۑ
			if(s2_set_stat == 1){			// @XCb`ꂽ
				tate_bit_num++;				// common(col) bit number +1
				tate_bit_num &= 0x0f;
			}
		}

		delay_ms(10);						// 10mS Delay
		count_for_1sec++;
		if(100 <= count_for_1sec){
			count_for_1sec = 0;
		}
	}

}
#else
 #ifdef cpu2560
//***************************
// 8x48 dot Dispaly X^eBbN`FbN mega2560
//  ݋֎~ԂŌĂ΂鎖
//  荞݂g킸ɁAX^eBbN
//  ehbg̕\B
//  ォ牺ɂPhbgPbԊuœA
//  JԂB
//  rłrdkdbsXCb`ꂽA
//  ㉺̕\ʒu͂̂܂܂ɂB
//  ÉArdsXCb`ꂽAB
//
//  ̊֐͔ɉiɓJԂ
//***************************
void	check_8x48_dot_static(void)
{
	unsigned char	uc;
	unsigned char	stop_yoko_run=0;		// 1 :row bit number inc. stop
	unsigned char	yoko_bit=0x01;			// row bit data
	unsigned char	tate_bit_num=0;			// common(col) bit number
	unsigned char	s1_select_stat=0;		// SELECT SW
	unsigned char	s2_set_stat=0;			// SET SW
	unsigned char	count_for_1sec=0;		// counter for 1sec


	PORTA = ~yoko_bit;						// row set block-1
	PORTC = ~yoko_bit;						// row set block-2
	PORTE = ~yoko_bit;						// row set block-3
	PORTH |= col_data_PH[tate_bit_num];		// common[E1] set
	PORTJ |= col_data_PJ[tate_bit_num];		// common[E2] set
	PORTK |= col_data_PK[tate_bit_num];		// common[E3] set
	PORTL |= col_data_PL[tate_bit_num];		// common[E4] set
	PORTG |= col_data_PG[tate_bit_num];		// common[E5] set
	PORTD |= col_data_PD[tate_bit_num];		// common[E5] set
	PORTF |= col_data_PF[tate_bit_num];		// common[E6] set
	PORTB |= col_data_PB[tate_bit_num];		// common[E6] set

	wait_sw_off();							// Q̃XCb`Q@܂ŉiv[v

	while(1){
		if(count_for_1sec == 0){
			PORTH &= col_data_PH_off;		// common[E1] off
			PORTJ &= col_data_PJ_off;		// common[E2] off
			PORTK &= col_data_PK_off;		// common[E3] off
			PORTL &= col_data_PL_off;		// common[E4] off
			PORTG &= col_data_PG_off;		// common[E5] off
			PORTD &= col_data_PD_off;		// common[E5] off
			PORTF &= col_data_PF_off;		// common[E6] off
			PORTB &= col_data_PB_off;		// common[E6] off
			if(stop_yoko_run == 0){			// togle row bit number inc. stop
				PORTA = ~yoko_bit;			// row set block-1
				PORTC = ~yoko_bit;			// row set block-2
				PORTE = ~yoko_bit;			// row set block-3
				yoko_bit <<= 1;
				if(yoko_bit==0){
					yoko_bit = 0x01;
				}
			}
			PORTH |= col_data_PH[tate_bit_num];		// common[E1] set
			PORTJ |= col_data_PJ[tate_bit_num];		// common[E2] set
			PORTK |= col_data_PK[tate_bit_num];		// common[E3] set
			PORTL |= col_data_PL[tate_bit_num];		// common[E4] set
			PORTG |= col_data_PG[tate_bit_num];		// common[E5] set
			PORTD |= col_data_PD[tate_bit_num];		// common[E5] set
			PORTF |= col_data_PF[tate_bit_num];		// common[E6] set
			PORTB |= col_data_PB[tate_bit_num];		// common[E6] set
		}

		uc = check_s1_sw_on();				// SET
		if(s1_select_stat != uc){			// Ԃς
			s1_select_stat = uc;			// ݂̏ԕۑ
			if(s1_select_stat == 1){		// @XCb`ꂽ
				stop_yoko_run ^= 1;			// togle row bit number inc. stop
			}
		}

		uc = check_s2_sw_on();				// SELECTT
		if(s2_set_stat != uc){				// Ԃς
			s2_set_stat = uc;				// ݂̏ԕۑ
			if(s2_set_stat == 1){			// @XCb`ꂽ
				tate_bit_num++;				// common(col) bit number +1
				tate_bit_num &= 0x0f;
			}
		}

		delay_ms(10);						// 10mS Delay
		count_for_1sec++;
		if(100 <= count_for_1sec){
			count_for_1sec = 0;
		}
	}

}
 #endif
#endif

#ifdef	cpu64
//***************************
// 8x48 dot Dynamic Dispaly 
//  ݋֎~ԂŌĂ΂鎖
//***************************
void	disp_8x48_dot_init(void)
{
	PORTA = row_data_off;			// row off block-1
	PORTB = row_data_off;			// row off block-2
	PORTC = row_data_off;			// row off block-3

	PORTD &= col_data_PD_off;		// common off
	PORTE &= col_data_PE_off;		// common off
	PORTF &= col_data_PF_off;		// common off

	DDRA = 0xff;					// PORTA(row) ALLBIT OUTPUT
	DDRB = 0xff;					// PORTB(row) ALLBIT OUTPUT
	DDRC = 0xff;					// PORTC(row) ALLBIT OUTPUT

	DDRD |= ((1 << DDD4) | (1 << DDD5) | (1 << DDD6) | (1 << DDD7));				// PORTD(common) D4 -- D7 OUTPUT
	DDRE |= ((1 << DDE2) | (1 << DDE4) | (1 << DDE5) | (1 << DDE6) | (1 << DDE7));	// PORTE(common) E2, E4 -- E7 OUTPUT
	DDRF |= ((1 << DDF1) | (1 << DDF2) | (1 << DDF3) | (1 << DDF4) | (1 << DDF5) | (1 << DDF6) | (1 << DDF7));	// PORTE(common) F1 --F7 OUTPUT

}
#else
 #ifdef cpu2560
//***************************
// 8x48 dot Dynamic Dispaly 
//  ݋֎~ԂŌĂ΂鎖
//***************************
void	disp_8x48_dot_init(void)
{
	PORTA = row_data_off;			// row off block-1
	PORTC = row_data_off;			// row off block-2
	PORTE = row_data_off;			// row off block-3

	PORTH &= col_data_PH_off;		// common[E1] off
	PORTJ &= col_data_PJ_off;		// common[E2] off
	PORTK &= col_data_PK_off;		// common[E3] off
	PORTL &= col_data_PL_off;		// common[E4] off
	PORTG &= col_data_PG_off;		// common[E5] off
	PORTD &= col_data_PD_off;		// common[E5] off
	PORTF &= col_data_PF_off;		// common[E6] off
	PORTB &= col_data_PB_off;		// common[E6] off

	DDRA = 0xff;					// PORTA(row) ALLBIT OUTPUT
	DDRC = 0xff;					// PORTC(row) ALLBIT OUTPUT
	DDRE = 0xff;					// PORTE(row) ALLBIT OUTPUT

	DDRH = 0xff;					// PORTH(col E1) ALLBIT OUTPUT
	DDRJ = 0xff;					// PORTH(col E2) ALLBIT OUTPUT
	DDRK = 0xff;					// PORTH(col E3) ALLBIT OUTPUT
	DDRL = 0xff;					// PORTH(col E4) ALLBIT OUTPUT
	DDRG |= ((1 << DDG0) | (1 << DDG1) | (1 << DDG2) | (1 << DDG3));				// PORTG(col E5) G0 -- G3 OUTPUT
	DDRD |= ((1 << DDD4) | (1 << DDD5) | (1 << DDD6) | (1 << DDD7));				// PORTD(col E5) D4 -- D7 OUTPUT
	DDRB |= (1 << DDB0);																						// PORTB(col E6) B0 OUTPUT
	DDRF |= ((1 << DDF1) | (1 << DDF2) | (1 << DDF3) | (1 << DDF4) | (1 << DDF5) | (1 << DDF6) | (1 << DDF7));	// PORTF(Col E6) F1 --F7 OUTPUT

}
 #endif
#endif

#ifdef	cpu64
//***************************
// 8x48 dot Dynamic Dispaly mega64
// 200uS Timer ݂ŌĂ΂
//***************************
void	disp_8x48_dot_led(void)
{
	static	unsigned char	count=0;
	static	unsigned char	pass_count=0;
	static	unsigned char	sSet_count = 0;

	// qnvJ\[h
	PORTA = row_data_off;				// row off block-1
	PORTB = row_data_off;				// row off block-2
	PORTC = row_data_off;				// row off block-3

	// bnllnmAm[h
	PORTD &= col_data_PD_off;			// common off
	PORTE &= col_data_PE_off;			// common off
	PORTF &= col_data_PF_off;			// common off


	if(sSet_count <= pass_count){
		PORTA = row_data[count+0];		// row set block-1
		PORTB = row_data[count+16];		// row set block-2
		PORTC = row_data[count+32];		// row set block-3

		PORTD |= col_data_PD[count];	// common set
		PORTE |= col_data_PE[count];	// common set
		PORTF |= col_data_PF[count];	// common set
	}

	pass_count++;
	pass_count &= 0x03;
	if(pass_count == 0){
		count++;
		count &= 0x0f;
		if(count == 0){
			sSet_count = gSet_count;
		}
	}

}
#else
 #ifdef cpu2560
//***************************
// 8x48 dot Dynamic Dispaly mega2560
// 200uS Timer ݂ŌĂ΂
//***************************
void	disp_8x48_dot_led(void)
{
	static	unsigned char	count=0;
	static	unsigned char	pass_count=0;
	static	unsigned char	sSet_count = 0;

	// qnvJ\[h
	PORTA = row_data_off;				// row off block-1
	PORTC = row_data_off;				// row off block-2
	PORTE = row_data_off;				// row off block-3

	// bnkDibnllnmjAm[h
	PORTH &= col_data_PH_off;			// common[E1] off
	PORTJ &= col_data_PJ_off;			// common[E2] off
	PORTK &= col_data_PK_off;			// common[E3] off
	PORTL &= col_data_PL_off;			// common[E4] off
	PORTG &= col_data_PG_off;			// common[E5] off
	PORTD &= col_data_PD_off;			// common[E5] off
	PORTF &= col_data_PF_off;			// common[E6] off
	PORTB &= col_data_PB_off;			// common[E6] off


	if(sSet_count <= pass_count){
		PORTA = row_data[count+0];		// row set block-1
		PORTC = row_data[count+16];		// row set block-2
		PORTE = row_data[count+32];		// row set block-3

		PORTH |= col_data_PH[count];	// common[E1] set
		PORTJ |= col_data_PJ[count];	// common[E2] set
		PORTK |= col_data_PK[count];	// common[E3] set
		PORTL |= col_data_PL[count];	// common[E4] set
		PORTG |= col_data_PG[count];	// common[E5] set
		PORTD |= col_data_PD[count];	// common[E5] set
		PORTF |= col_data_PF[count];	// common[E6] set
		PORTB |= col_data_PB[count];	// common[E6] set
	}

	pass_count++;
	pass_count &= 0x03;
	if(pass_count == 0){
		count++;
		count &= 0x0f;
		if(count == 0){
			sSet_count = gSet_count;
		}
	}

}
 #endif
#endif

// *****************************
// ƉEւ
// *****************************
unsigned char	get_mirror_data(unsigned char uc)
{
	unsigned char	r = 0;
	unsigned char	bit_s = 0x80;
	unsigned char	bit_d = 0x01;
	unsigned char	i;

	for(i=0;i<8;i++,bit_s >>= 1, bit_d <<= 1){
		if((uc & bit_s) != 0){
			r |= bit_d;
		}
	}
	return(r);

}

// *****************************
// AXL[hbg}gbNXf[^ɕϊ
//	hbg}gNXf[^́@	row_data[48+8] ɓ
//
//  nFhbg}gbNXZbgꏊ(0 --> 43)
//  ucFAXL[f[^
//  rightFEl
//  mirror_upsidedownFA|̗L 0: 1: 2:| 3:| 4:XOxv]
// *****************************
void	asc_to_dotmatrix(unsigned char n,unsigned char uc,unsigned char	right,unsigned char mirror_upsidedown)
{
	unsigned short	us;
	unsigned char	c;
	unsigned char	i;

	us = uc;
	us &= 0x7f;
	us *= 5;

	for(i=0;i<5;i++){
		if((mirror_upsidedown == 2)||(mirror_upsidedown == 3)){
			c = pgm_read_byte(&font5x7[us + 4 - i]);
		}else{
			c = pgm_read_byte(&font5x7[us + i]);
		}

		if((mirror_upsidedown == 1)||(mirror_upsidedown == 3)){
			c = get_mirror_data(c);									// ƉEւ
		}

		row_data[n+i+right] = c;

	}
}
#ifdef	cpu64
// *****************************
// AXL[hbg}gbNXf[^ɕϊ mega64
//	hbg}gNXf[^́@	row_data[48+8] ɓ
//
//  nFhbg}gbNXZbgꏊ(0 --> 43)
//  uascFAXL[f[^
// *****************************
void	asc_to_rotate90(unsigned char n,unsigned char uasc,unsigned char secdot)
{
	unsigned short	us;
	unsigned char	uc[7];
	unsigned char	i;
	unsigned char	j;
	unsigned char	c;
	unsigned char	comp_c;
	unsigned char	b;
	unsigned char	hon_n;
	unsigned char	hon_n8;
	unsigned char	hon_np8;
	unsigned char	amari;
	unsigned char	hon_mask[8]={
									0b00000111,		// ܂O
									0b10000011,		// ܂P
									0b11000001,		// ܂Q
									0b11100000,		// ܂R
									0b11110000,		// ܂S
									0b11111000,		// ܂T
									0b11111100,		// ܂U
									0b11111110,		// ܂V
	};

	unsigned char	ato_mask[8]={
									0b11111111,		// ܂O
									0b11111111,		// ܂P
									0b11111111,		// ܂Q
									0b11111111,		// ܂R
									0b01111111,		// ܂S
									0b00111111,		// ܂T
									0b00011111,		// ܂U
									0b00001111,		// ܂V
	};

	if(n < 48){
		us = uasc;
		us *= 5;

		for(i=0;i<7;i++){						// NA
			uc[i] = 0;
		}

		b = 0x80;
		for(i=0;i<5;i++){
			if(secdot == 0){
				c = pgm_read_byte(&font5x7[us + i]);
			}else{
				c = pgm_read_byte(&secdot5x7[us + i]);
			}
			for(j=0;j<7;j++){
				if((c & 0x01)!=0){
					uc[j] |= b;
				}
				c >>= 1;
			}
			b >>= 1;
		}

		hon_n = n / 8;
		amari = n % 8;

		if(amari == 0){							// ܂肪́AʏŊȒPɂ
			for(i=0;i<7;i++){
				comp_c = ~(uc[i]);
				comp_c &= 0xf8;
				row_data[n+i] &= 0x07;			// 鏊NA
				row_data[n+i] |= comp_c;		// hbgf[^
			}
		}else{
			hon_n8 = hon_n*8;										// ŵWW
			hon_np8 = (hon_n+1)*8;									// w̎̂WW
			for(i=0;i<7;i++){
				comp_c = ~(uc[i]);
				comp_c &= 0xf8;
				row_data[hon_n8+i] &= hon_mask[amari];				// ŵWW𕔕NA
				row_data[hon_n8+i] |= (comp_c >> amari);			// ŵWWɕhbgf[^
				if(hon_np8 < 48){									// w̎̂WW͈͓̎
					row_data[hon_np8+i] &= ato_mask[amari];			// w̎̂WW𕔕NA
					row_data[hon_np8+i] |= (comp_c << (8-amari));	// w̎̂WWɕhbgf[^
				}
			}
		}
	}
}
#else
 #ifdef cpu2560
// *****************************
// AXL[hbg}gbNXf[^ɕϊ
//	hbg}gNXf[^́@	row_data[48+8] ɓ
//  for mega2560
//
//  nFhbg}gbNXZbgꏊ(0 --> 47)
//  uascFAXL[f[^
// *****************************
void	asc_to_rotate90(unsigned char n,unsigned char uasc,unsigned char secdot)
{
	unsigned short	us;
	unsigned char	uc[7];
	unsigned char	i;
	unsigned char	j;
	unsigned char	c;
	unsigned char	comp_c;
	unsigned char	b;
	unsigned char	hon_n;
	unsigned char	hon_n8;
	unsigned char	hon_np8;
	unsigned char	amari;
	unsigned char	hon_mask[8]={
									0b11100000,		// ܂O
									0b11000001,		// ܂P
									0b10000011,		// ܂Q
									0b00000111,		// ܂R
									0b00001111,		// ܂S
									0b00011111,		// ܂T
									0b00111111,		// ܂U
									0b01111111,		// ܂V
	};

	unsigned char	ato_mask[8]={
									0b11111111,		// ܂O
									0b11111111,		// ܂P
									0b11111111,		// ܂Q
									0b11111111,		// ܂R
									0b11111110,		// ܂S
									0b11111100,		// ܂T
									0b11111000,		// ܂U
									0b11110000,		// ܂V
	};

	if(n < 48){
		us = uasc;
		us *= 5;

		for(i=0;i<7;i++){						// NA
			uc[i] = 0;
		}

		b = 0x01;
		for(i=0;i<5;i++){
			if(secdot == 0){
				c = pgm_read_byte(&font5x7[us + i]);
			}else{
				c = pgm_read_byte(&secdot5x7[us + i]);
			}
			for(j=0;j<7;j++){
				if((c & 0x01)!=0){
					uc[j] |= b;
				}
				c >>= 1;
			}
			b <<= 1;
		}

		hon_n = n / 8;
		amari = n % 8;

		if(amari == 0){							// ܂肪́AʏŊȒPɂ
			for(i=0;i<7;i++){
				comp_c = ~(uc[i]);

				comp_c &= 0x1f;
				row_data[n+i] &= 0xe0;			// 鏊NA
				row_data[n+i] |= comp_c;		// hbgf[^
			}
		}else{
			hon_n8 = hon_n*8;										// ŵWW
			hon_np8 = (hon_n+1)*8;									// w̎̂WW
			for(i=0;i<7;i++){
				comp_c = ~(uc[i]);
				comp_c &= 0x1f;

				row_data[hon_n8+i] &= hon_mask[amari];				// ŵWW𕔕NA
				row_data[hon_n8+i] |= (comp_c << amari);			// ŵWWɕhbgf[^
				if(hon_np8 < 48){									// w̎̂WW͈͓̎
					row_data[hon_np8+i] &= ato_mask[amari];			// w̎̂WW𕔕NA
					row_data[hon_np8+i] |= (comp_c >> (8-amari));	// w̎̂WWɕhbgf[^
				}
			}
		}
	}
}
 #endif
#endif

#ifdef	cpu64
// *****************************
// jf[^hbg}gbNXf[^ɕϊ
//	hbg}gNXf[^́@	row_data[48+8] ɓ
//  for mega64
//
//  nFhbg}gbNXZbgꏊ(0 --> 43)
//  wdFjf[^iOFAPFADDDDVFyj
// *****************************
void	wd_to_dotmatrix(unsigned char n,unsigned char wd)
{
	unsigned short	us;
	unsigned char	uc[7];
	unsigned char	i;
	unsigned char	comp_c;
	unsigned char	b;
	unsigned char	hon_n;
	unsigned char	hon_n8;
	unsigned char	hon_np8;
	unsigned char	amari;
	unsigned char	wd_hon_mask[8]={
									0b00000000,		// ܂O
									0b10000000,		// ܂P
									0b11000000,		// ܂Q
									0b11100000,		// ܂R
									0b11110000,		// ܂S
									0b11111000,		// ܂T
									0b11111100,		// ܂U
									0b11111110,		// ܂V
	};

	unsigned char	wd_ato_mask[8]={
									0b11111111,		// ܂O
									0b01111111,		// ܂P
									0b00111111,		// ܂Q
									0b00011111,		// ܂R
									0b00001111,		// ܂S
									0b00000111,		// ܂T
									0b00000011,		// ܂U
									0b00000001,		// ܂V
	};

	if(n<48){								// WSWhbg}gNX͈͓̔̎
		us = wd;
		us &= 0x1f;
		us *= 8;

		for(i=0;i<7;i++){						// NA
			uc[i] = 0;
		}

		b = 0x01;
		for(i=0;i<7;i++){
			uc[i] = pgm_read_byte(&font8x8_day_of_week[us + i]);
		}

		hon_n = n / 8;
		amari = n % 8;

		if(amari == 0){							// ܂肪́AʏŊȒPɂ
			for(i=0;i<7;i++){
				comp_c = ~(uc[i]);
				row_data[n+i] &= 0x00;			// 鏊NA
				row_data[n+i] |= comp_c;		// hbgf[^
			}
		}else{
			hon_n8 = hon_n*8;										// ŵWW
			hon_np8 = (hon_n+1)*8;									// w̎̂WW
			for(i=0;i<7;i++){
				comp_c = ~(uc[i]);
				row_data[hon_n8+i] &= wd_hon_mask[amari];			// ŵWW𕔕NA
				row_data[hon_n8+i] |= (comp_c >> amari);			// ŵWWɕhbgf[^
				if(hon_np8 < 48){									// w̎̂WW͈͓̎
					row_data[hon_np8+i] &= wd_ato_mask[amari];		// w̎̂WW𕔕NA
					row_data[hon_np8+i] |= (comp_c << (8-amari));	// w̎̂WWɕhbgf[^
				}
			}
		}
	}
}
#else
 #ifdef cpu2560
// *****************************
// jf[^hbg}gbNXf[^ɕϊ
//	hbg}gNXf[^́@	row_data[48+8] ɓ
//  for mega2560
//
//  nFhbg}gbNXZbgꏊ(0 --> 47)
//  wdFjf[^iOFAPFADDDDVFyj
// *****************************
void	wd_to_dotmatrix(unsigned char n,unsigned char wd)
{
	unsigned short	us;
	unsigned char	uc[7];
	unsigned char	i;
	unsigned char	c;
	unsigned char	comp_c;
	unsigned char	b;
	unsigned char	hon_n;
	unsigned char	hon_n8;
	unsigned char	hon_np8;
	unsigned char	amari;
	unsigned char	wd_hon_mask[8]={
									0b00000000,		// ܂O
									0b00000001,		// ܂P
									0b00000011,		// ܂Q
									0b00000111,		// ܂R
									0b00001111,		// ܂S
									0b00011111,		// ܂T
									0b00111111,		// ܂U
									0b01111111,		// ܂V
	};

	unsigned char	wd_ato_mask[8]={
									0b11111111,		// ܂O
									0b11111110,		// ܂P
									0b11111100,		// ܂Q
									0b11111000,		// ܂R
									0b11110000,		// ܂S
									0b11100000,		// ܂T
									0b11000000,		// ܂U
									0b10000000,		// ܂V
	};

	if(n<48){								// WSWhbg}gNX͈͓̔̎
		us = wd;
		us &= 0x1f;
		us *= 8;

		for(i=0;i<7;i++){						// NA
			uc[i] = 0;
		}

		b = 0x01;
		for(i=0;i<7;i++){
			c = pgm_read_byte(&font8x8_day_of_week[us+i]);
			uc[i] = get_mirror_data(c);			// ƉEւ
		}

		hon_n = n / 8;
		amari = n % 8;

		if(amari == 0){							// ܂肪́AʏŊȒPɂ
			for(i=0;i<7;i++){
				comp_c = ~(uc[i]);
				row_data[n+i] &= 0x00;			// 鏊NA
				row_data[n+i] |= comp_c;		// hbgf[^
			}
		}else{
			hon_n8 = hon_n*8;										// ŵWW
			hon_np8 = (hon_n+1)*8;									// w̎̂WW
			for(i=0;i<7;i++){
				comp_c = ~(uc[i]);
				row_data[hon_n8+i] &= wd_hon_mask[amari];			// ŵWW𕔕NA
				row_data[hon_n8+i] |= (comp_c << amari);			// ŵWWɕhbgf[^
				if(hon_np8 < 48){									// w̎̂WW͈͓̎
					row_data[hon_np8+i] &= wd_ato_mask[amari];		// w̎̂WW𕔕NA
					row_data[hon_np8+i] |= (comp_c >> (8-amari));	// w̎̂WWɕhbgf[^
				}
			}
	
		}
	}
}
 #endif
#endif

#ifdef	cpu64
// *****************************
// cC𔽓] mage64
//	hbg}gNXf[^́@	row_data[48+8] ɗL
//  for mega64
//
//  nF]ꏊ(0 --> 47)
// *****************************
void	disp_tate1_compliment(unsigned char n)
{
	unsigned char	i;
	unsigned char	comp_c;
	unsigned char	hon_n;
	unsigned char	amari;

	if(n<48){								// WSWhbg}gNX͈͓̔̎
		hon_n = n / 8;
		amari = n % 8;

		hon_n *= 8;								// ŵWW
		comp_c = (0x80 >> amari);
		for(i=0;i<8;i++){
			row_data[hon_n+i] ^= comp_c;		// ]hbgf[^
		}
	}
}
#else
 #ifdef cpu2560
// *****************************
// cC𔽓] mega2560
//	hbg}gNXf[^́@	row_data[48+8] ɗL
//  for mega2560
//
//  nF]ꏊ(0 --> 47)
// *****************************
void	disp_tate1_compliment(unsigned char n)
{
	unsigned char	i;
	unsigned char	comp_c;
	unsigned char	hon_n;
	unsigned char	amari;

	if(n<48){								// WSWhbg}gNX͈͓̔̎
		hon_n = n / 8;
		amari = n % 8;

		hon_n *= 8;								// ŵWW
		comp_c = (0x01 << amari);
		for(i=0;i<8;i++){
			row_data[hon_n+i] ^= comp_c;		// ]hbgf[^
		}
	}
}
 #endif
#endif

enum DISP_FUNC_ITEM {		// \֐
		F_5x7 = 0,			// TV\
		F_8x8,				// WW\
		F_5x7_DOT,			// bp_X̂TV\

		F_END
	};


struct DISP_8x48_ITEM {
	unsigned char i_clock;		//\镨
	unsigned char i_dmode;		//\鎞̃[h
	unsigned char i_fsize;		//\tHgTCY
	unsigned char i_x;			//\ʒuw
	unsigned char *i_bcd;		//\f[^

};

struct DISP_8x48_CONST {
	unsigned char c_dmode;		//\鎞̃[h
	unsigned char c_fsize;		//\tHgTCY
	unsigned char c_x;			//\ʒuw
	unsigned char c_dt;			//

};


static
struct DISP_8x48_CONST	gDisp_8x48__const[]={
	{YEAR,      F_5x7,   3*6, '2'},			// '2'
	{YEAR,      F_5x7,   4*6, '0'},			// '0'
	{YMD,       F_5x7,   2*6, '/'},			// '/'
	{YMD,       F_5x7,   5*6, '/'},			// '/'
	{SYMD,      F_5x7,   2*6, '/'},			// '/'
	{SYMD,      F_5x7,   5*6, '/'},			// '/'
	{WMD,       F_5x7, 3*8+2, '/'},			// '/'
	{HMS,       F_5x7,   2*6, ':'},			// ':'
	{HMS,       F_5x7,   5*6, ':'},			// ':'
	{SHMS,      F_5x7,   2*6, ':'},			// ':'
	{SHMS,      F_5x7,   5*6, ':'},			// ':'
	{WHM,       F_5x7, 3*8+1, ':'},			// ':'
	{WHMS,      F_5x7, 3*8+1, ':'},			// ':'
	{CdsTempe,  F_5x7,   2*6, 0xdf},		// ''
	{CdsTempe,  F_5x7,   2*8, 'C'},			// 'C'
	{WCdsTempe, F_5x7,   2*6, 0xdf},		// ''
	{WCdsTempe, F_5x7,   2*8, 'C'},			// 'C'

	{M_END,     F_END,   0,    0},			// I
};


static
struct DISP_8x48_ITEM	sDisp_8x48_item[]={
//\镨,  \[h, \tHgTCY, \ʒuw, \f[^

	{I_YEAR, 		YEAR,      F_5x7,            5*6, (unsigned char *)&gRTC_year},		// Year
	{I_YEAR, 		YMD,       F_5x7,            0*6, (unsigned char *)&gRTC_year},		// Year
	{I_MON,  		YMD,       F_5x7,            3*6, (unsigned char *)&gRTC_mon},		// Month
	{I_MON,  	    WMD,       F_5x7,          1*8+4, (unsigned char *)&gRTC_mon},		// Month
	{I_DAY,  		YMD,       F_5x7,            6*6, (unsigned char *)&gRTC_day},		// Day
	{I_DAY,  		WMD,       F_5x7,          4*8+0, (unsigned char *)&gRTC_day},		// Day
	{I_HOUR, 		HMS,       F_5x7,            0*6, (unsigned char *)&gRTC_hou},		// Hour
	{I_HOUR, 		WHM,       F_5x7,          1*8+3, (unsigned char *)&gRTC_hou},		// Hour
	{I_HOUR, 		WHMS,      F_5x7,          1*8+3, (unsigned char *)&gRTC_hou},		// Hour
	{I_MIN,  		HMS,       F_5x7,            3*6, (unsigned char *)&gRTC_min},		// Min
	{I_MIN,  		WHM,       F_5x7,          4*8-1, (unsigned char *)&gRTC_min},		// Min
	{I_MIN,  		WHMS,      F_5x7,          4*8-1, (unsigned char *)&gRTC_min},		// Min
	{I_SEC,  		HMS,       F_5x7,            6*6, (unsigned char *)&gRTC_sec},		// Sec
	{I_SEC,  		WHMS,      F_5x7_DOT,       7*6+1, (unsigned char *)&gRTC_sec},		// Sec
	{I_TEMPE,		CdsTempe,  F_5x7,            0*6, (unsigned char *)&gRTC_tempe},	// Tempe
	{I_BRIGHT,		CdsTempe,  F_5x7,          4*6+5, (unsigned char *)&gAd0_ave},		// Brightness
	{I_TEMPE,		WCdsTempe, F_5x7,            0*6, (unsigned char *)&gRTC_tempe},	// Tempe
	{I_BRIGHT,		WCdsTempe, F_5x7,          4*6+5, (unsigned char *)&gAd0_ave},		// Brightness
	{I_WD,  		WHM,       F_8x8,            0*8, (unsigned char *)&gRTC_wday},		// Day of Week
	{I_WD,  		WHMS,      F_8x8,            0*8, (unsigned char *)&gRTC_wday},		// Day of Week
	{I_WD,  		WMD,       F_8x8,            0*8, (unsigned char *)&gRTC_wday},		// Day of Week
	{I_WD,  		YEAR,      F_8x8,            0*8, (unsigned char *)&gRTC_wday},		// Day of Week
	{I_YEAR, 		SYMD,      F_5x7,            0*6, (unsigned char *)&gRTC_year},		// Year
	{I_MON,  		SYMD,      F_5x7,            3*6, (unsigned char *)&gRTC_mon},		// Month
	{I_DAY,  		SYMD,      F_5x7,            6*6, (unsigned char *)&gRTC_day},		// Day
	{I_HOUR, 		SHMS,      F_5x7,            0*6, (unsigned char *)&gRTC_hou},		// Hour
	{I_MIN,  		SHMS,      F_5x7,            3*6, (unsigned char *)&gRTC_min},		// Min
	{I_SEC,  		SHMS,      F_5x7,            6*6, (unsigned char *)&gRTC_sec},		// Sec

	{I_END,         M_END,     F_END,              0, (unsigned char *)&gRTC_sec},		// I
};

//*****************************************
// Ԗڂ߂
//*****************************************
static
unsigned char	get_disp_8x48_block_num(unsigned char inum)
{
	unsigned char	uc;

	for(uc = 0; ; uc++){
		if((sDisp_8x48_item[uc].i_clock == inum)&&(sDisp_8x48_item[uc].i_dmode == gDisp_clock_mode)){
			break;
		}else if(sDisp_8x48_item[uc].i_clock == I_END){
			break;
		}else if(sDisp_8x48_item[uc].i_fsize == F_END){
			break;
		}
	}

	return(uc);
}
//******************************
// display 8x48 LED(8char)
//  pos_x : Position X(0 -- 47)
//  ubcc  : sec data(BCD 0 <--> 59)
// *****************************
void	disp_8x48_G_secdot(unsigned char pos_x, unsigned char ubcd)
{
	unsigned char	uc;

	uc = ubcd & 0x0f;
	uc += ((ubcd >> 4)&0x0f)*10;
	if(pos_x <= 47){
		asc_to_rotate90(pos_x,uc,1);
	}
}

//******************************
// display 8x48 LED(8char)
//  pos_x : Position X(0 -- 47)
//  ucp : String(termnate 0x00)
// *****************************
void	disp_8x48_G_5x7(unsigned char pos_x, unsigned char *ucp)
{
	unsigned char	x;

	x = (pos_x % 47);

	while(*ucp != 0x00){						// String Data Out
		asc_to_rotate90(x,*ucp,0);

		x += 6;
		ucp++;
	}
}
//******************************
// clear 8x48 All LED(6char)
// *****************************
void	clear_8x48_G(void)
{
	unsigned char	i;

	for(i=0;i<48;i++){
		row_data[i] = 0xff;			// WW𕔕NA
	}

}
//******************************
// display 8x48 LED(6char)
//  pos_x : Position X(0 -- 47)
//  uc : 0b00000001(j <--> 0b01000000(y)
// *****************************
void	disp_8x48_G_wd(unsigned char pos_x, unsigned char uc)
{
	unsigned char	x;
	unsigned char	wd;

	x = (pos_x % 47);

	for(wd = 0;wd < 8; wd++,uc>>=1){
		if((uc & 0x01)!=0){
			break;
		}
	}

	wd_to_dotmatrix(x,wd);

}

// *****************************
// j\Ă鎞̕b\NA
// *****************************
void clear_sec_dot(void)
{
	unsigned char		bn;
	unsigned char		pos_x;					// hbgPʂ̂wʒu

	bn = get_disp_8x48_block_num(I_SEC);		// Ԗڂ߂
	pos_x = sDisp_8x48_item[bn].i_x;			// pos_x

	disp_8x48_G_secdot(pos_x, 0x60);				// x, dot data(5x7) 60(BCD):clear
}

//*****************************************
// vf[^̕\
//  Pڂ̕\
//  item_num : \镨̎
//      disp : 1=\A 0=iXy[X\j
//*****************************************
void	disp_8x48_clock_item(unsigned char item_num, unsigned char disp)
{
	unsigned char		bn;
	unsigned char		ucbf[4]={' ',' ',0,0};
	unsigned char		pos_x;					// hbgPʂ̂wʒu
	unsigned char		uc;						// f[^
	unsigned short		us;						// f[^
	unsigned char		u_func;					// gp֐

	bn = get_disp_8x48_block_num(item_num);		// Ԗڂ߂
	u_func = sDisp_8x48_item[bn].i_fsize;		// gptHg̎
	pos_x = sDisp_8x48_item[bn].i_x;			// pos_x
	uc = *(sDisp_8x48_item[bn].i_bcd);			// data

	if(disp == 1){
		if(item_num == I_BRIGHT){				// 邳̃f[^̎
			us = *((unsigned short*)(sDisp_8x48_item[bn].i_bcd));			// data
			set_hex_3(&(ucbf[0]), us);			// gdwimax 0xfff)AXL[Rɂ
		}else{
			if(item_num == I_TEMPE){			// TEMP Reg. ̃f[^̎
				uc = calcu_tempe(uc);			// xlɌvZ
			}
			set_hex_2(&(ucbf[0]), uc);			// abcimax 0x99)AXL[Qɂ
		}
	}
	if(u_func == F_8x8){
		disp_8x48_G_wd(pos_x, uc);				// x, data(8x8)
	}else if(u_func == F_5x7_DOT){
		disp_8x48_G_secdot(pos_x, uc);			// x, dot data(5x7)
	}else if(u_func == F_5x7){
		disp_8x48_G_5x7(pos_x, ucbf);			// x, data(5x7)
	}
}

//*****************************************
// v̌Œ\
//*****************************************
void	disp_8x48_clock_const(void)
{
	unsigned char		bn;
	unsigned char		uc;
	unsigned char		pos_x;				// hbgPʂ̂wʒu
	unsigned char		u_func;				// gp֐

	for(bn = 0;  ;bn++){
		if(gDisp_8x48__const[bn].c_dmode == M_END){	// \[h lQdmc͕̎\ȂŏI
			break;
		}

		if(gDisp_clock_mode == gDisp_8x48__const[bn].c_dmode){	// \[h̎
			u_func = gDisp_8x48__const[bn].c_fsize;		// gp֐̎
			pos_x = gDisp_8x48__const[bn].c_x;			// pos_x
			uc = gDisp_8x48__const[bn].c_dt;			// \

			if(u_func == F_8x8){
				disp_8x48_G_wd(pos_x, uc);				// x, BCD data(8x8)
			}else{
				asc_to_rotate90(pos_x, uc, 0);			// x, data (5x7)
			}
		}
	}
}

//*****************************************
// WW̕\
//  wf[^̕\
//  num : \f[^
//     x: \ʒuiO||SVj
//   pcp: \f[^
//*****************************************
void	disp_8x8_item(unsigned char num, unsigned char x, unsigned char *puc)
{
	unsigned char		i;

	for(i=0; i < num; i++, x += 8, puc++){
		if(x < 48){
			wd_to_dotmatrix(x, *puc);				// x, data(8x8)
		}
	}
}
//*****************************************
// WŴPubN̂PC]\
//     x: \ʒuiO||SVj
//*****************************************
void	disp_1x8_compliment(unsigned char x)
{
	if((0 <= x)&&(x <= 47)){
		row_data[x] ^= 0xff;			// ŵPW𔽓]
	}
}
