//*****************************************
// Photo Box with ATmega64 or Atmega2560
// CPU Clock:O16MHz Ext,Crystal 16MHz)
//   iq[Yf[^@WȂŊOUɂj
//
//@OLED 128x64 Control IC: SSD1306
//    ĤPQWUŜnkdc\ihhbj
//
// File Name:oled_1306_h.h
//
//  C:\WinAVR-20100110\doc\avr-libc\avr-libc-user-manual.pdf ɊeCN[ht@C̐
//
//  2014/03/28 New
//  2014/12/21 modify for ATMEGA328
//  2023/03/07 Modify for mega328_i2c_oled Taishi
//  2023/05/13 Modify for mega328_iic_oled_rtc Taishi
//  2023/12/09 Modify for Photo Box with ATmega64 Taishi
//  2024/01/09 Modify for Photo Box with ATmega64 or ATmega2560 Taishi
//*****************************************

#define		SD1306_ADDR					0x78					// I2C OLED ̃foCXAhX 
#define		TW_WRITE					0x00					// ̃f[^͏o͂ɂȂ
#define		TW_READ						0x01					// ̃f[^͓͂ɂȂ

#define		SD1306_CONTROL_CMD_MONO		0x80					// R}h( Address,Control,Command)
#define		SD1306_CONTROL_CMD_MULTI	0x00					// R}h( Address,Control,Command1,Domanndo2,.......)
#define		SD1306_CONTROL_DATA_MULTI	0x40					// f[^( ADDRESS,Control,Data1,Data2,.......)

// ******** Global Data ********
extern	unsigned char	disp_moji[43];							// nkdc\


// ******* Global Function ******
extern	void	init_oled_G(void);																			// Init. OLED
extern	void	disp_clear_oled_G(void);																	// Clear All Display
extern	void	disp_clear_oled_G_reverse(void);															// Clear All Display Reversei]\j
extern	void	disp_line_clear_oled_G(unsigned char y);													// One Line Clear Display
extern	void	disp_line_clear_oled_G_reverse(unsigned char y);											// One Line Clear Display i]\j
extern	void	disp_one_char_oled_G(unsigned char pos_x, unsigned char pos_y, unsigned char uc);			// display OLED One charcter
extern	void	disp_one_char_oled_G_reverse(unsigned char pos_x, unsigned char pos_y, unsigned char uc);	// display OLED One charcteri]\j
extern	void	disp_oled_G(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp);					// display OLED(20char x 8Line)
extern	void	disp_oled_G_reverse(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp);			// display OLED(20char x 8Line, ]\)

extern	void	disp_one_char_oled_G_12x16(unsigned char pos_x, unsigned char pos_y, unsigned char uc);		// display OLED One charcter 10x16 Font
extern	void	disp_oled_G_12x16(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp);			// display OLED 10x16 Font (10char x 4Line)
extern	void	disp_one_char_oled_G_18x24(unsigned char pos_x, unsigned char pos_y, unsigned char uc);		// display OLED One charcter 15x24 Font
extern	void	disp_oled_G_18x24(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp);			// display OLED 15x24 Font (8char x 2Line)
extern	void	disp_one_char_oled_G_24x32(unsigned char pos_x, unsigned char pos_y, unsigned char uc);		// display OLED One charcter 24x32 Font
extern	void	disp_oled_G_24x32(unsigned char pos_x, unsigned char pos_y, unsigned char *ucp);			// display OLED 24x32 Font (4char x 1Line)


// ******* Global Function for Check ******
extern	void	disp_oled_G_font_check1(void);
extern	void	disp_oled_G_font_check2(void);
extern	void	disp_oled_G_reverse_font_check1(void);
extern	void	disp_oled_G_reverse_font_check2(void);
